#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;
int k = 0;
vector<pair<int, int>> d = { {1, 0}, {0, 1}, {-1, 0}, {0, -1} };
int n, m;
void dfs(int i, int j, const vector<vector<int>>& mp, vector<vector<int>>& rw) {
    rw[i][j] = k;
    for (auto w : d) {
        int x = i + w.first;
        int y = j + w.second;
        if (x < 0 || y < 0 || x >= n || y >= m)
            continue;
        if (mp[i][j] != mp[x][y] || rw[x][y] != -1)
            continue;
        dfs(x, y, mp, rw);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j];
    vector<vector<int>> rw(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (rw[i][j] == -1) {
                dfs(i, j, a, rw);
                k++;
            }
    int ans = 2 * k;
    vector<bool> rz(k);
    for (int j = 1; j < m; j++) {
        int nw = k;
        for (int i = 0; i < n; i++)
            if (rw[i][j - 1] == rw[i][j]) {
                if (!rz[rw[i][j]])
                    nw++;
                rz[rw[i][j]] = true;
            }
        ans = min(ans, nw);
        for (int i = 0; i < n; i++)
            rz[rw[i][j]] = false;
    }
    cout << ans << "\n";
}