#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;
int k = 0;
vector<pair<int, int>> d = { {1, 0}, {0, 1}, {-1, 0}, {0, -1} };
int n, m;
struct dsu {
    vector<int> p;
    int sz = n;
    dsu(int n) {
        p.assign(n, -1);
        sz = n;
    }
    int get(int v) {
        if (p[v] == -1)
            return v;
        p[v] = get(p[v]);
        return p[v];
    }
    void join(int v, int u) {
        v = get(v);
        u = get(u);
        if (v < u)
            swap(v, u);
        p[v] = u;
    }
};

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j];
    vector<int> dpp(m), dps(m);

    vector<vector<int>> rwp(n, vector<int>(m, -1));

    rwp[0][0] = 0;
    for (int i = 1; i < n; i++)
        if (a[i][0] == a[i - 1][0])
            rwp[i][0] = rwp[i - 1][0];
        else
            rwp[i][0] = rwp[i - 1][0] + 1;
    dpp[0] = rwp[n - 1][0] + 1;
    for (int j = 1; j < m; j++) {
        dpp[j] = dpp[j - 1];
        dsu ds = dsu(n * 2);

        set<int> st;
        if (a[0][j] == a[0][j - 1]) {
            ds.join(0, n + rwp[0][j - 1]);
            st.insert(rwp[0][j - 1]);
        }
        for (int i = 1; i < n; i++) {
            if (a[i][j] == a[i - 1][j]) 
                ds.join(i - 1, i);
            if (a[i][j] == a[i][j - 1]) {
                ds.join(i, n + rwp[i][j - 1]);
                st.insert(rwp[i][j - 1]);
            }
        }
        dpp[j] -= st.size();
        st.clear();
        for (int i = 0; i < n; i++) {
            rwp[i][j] = ds.get(i);
            st.insert(rwp[i][j]);
        }
        dpp[j] += st.size();
    }

    k = 0;
    vector<vector<int>> rws(n, vector<int>(m, -1));

    rws[0][m - 1] = 0;
    for (int i = 1; i < n; i++)
        if (a[i][m - 1] == a[i - 1][m - 1])
            rws[i][m - 1] = rws[i - 1][m - 1];
        else
            rws[i][m - 1] = rws[i - 1][m  - 1] + 1;
    dps[m - 1] = rws[n - 1][m - 1] + 1;
    for (int j = m - 2; j > -1; j--) {
        dps[j] = dps[j + 1];
        dsu ds = dsu(n * 2);

        set<int> st;
        if (a[0][j] == a[0][j + 1]) {
            ds.join(0, n + rws[0][j + 1]);
            st.insert(rws[0][j + 1]);
        }
        for (int i = 1; i < n; i++) {
            if (a[i][j] == a[i - 1][j])
                ds.join(i - 1, i);
            if (a[i][j] == a[i][j + 1]) {
                ds.join(i, n + rws[i][j + 1]);
                st.insert(rws[i][j + 1]);
            }
        }
        dps[j] -= st.size();
        st.clear();
        for (int i = 0; i < n; i++) {
            rws[i][j] = ds.get(i);
            st.insert(rws[i][j]);
        }
        dps[j] += st.size();
    }

    int ans = n * m;
    for (int j = 1; j < m; j++) 
        ans = min(ans, dpp[j - 1] + dps[j]);
    cout << ans << "\n";
}