#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;

struct dsu{
    vector<int> sz, p;
    int n, cnt;
    dsu(int ns){
        n = ns;
        cnt = 0;
        p.resize(n + 1);
        sz.resize(n + 1);
        for (int i = 1; i <= n; i++){
            p[i] = i;
            sz[i] = 1;
        }
    }
    int get(int v){
        if (p[v] != v){
            p[v] = get(p[v]);
        }
        return p[v];
    }
    void unite(int x, int y){
        x = get(x); y = get(y);
        if (x == y) return;
        if (sz[x] > sz[y]) swap(x, y);
        p[x] = y;
        sz[y] += sz[x];
        cnt--;
    }
};

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int h, w; cin>>h>>w;
    int x[h + 1][w + 1];
    for (int i = 1; i <= h; i++){
        for (int j = 1; j <= w; j++){
            cin>>x[i][j];
        }
    }
    auto f = [&](int i, int j){
        return (i - 1) * w + j;
    };
    int k = h * w;
    dsu T(k);
    vector<int> out(w);
    for (int j = 1; j < w; j++){
        for (int i = 1; i <= h; i++){
            // (i - 1, j)
            if (i > 1 && x[i - 1][j] == x[i][j]){
                T.unite(f(i - 1, j), f(i, j));
            }
            // (i + 1, j)
            if (i < h && x[i + 1][j] == x[i][j]){
                T.unite(f(i + 1, j), f(i, j));
            }
            // (i, j - 1)
            if (j > 1 && x[i][j - 1] == x[i][j]){
                T.unite(f(i, j - 1), f(i, j));
            }
        }
        T.cnt += h;
        out[j] = T.cnt;
        // T.cnt
    }
    dsu R(k);
    for (int j = w; j > 1; j--){
        for (int i = 1; i <= h; i++){
            if (i > 1 && x[i - 1][j] == x[i][j]){
                R.unite(f(i - 1, j), f(i, j));
            }
            if (i < h && x[i + 1][j] == x[i][j]){
                R.unite(f(i + 1, j), f(i, j));
            }
            if (x[i][j] == x[i][j + 1]){
                R.unite(f(i, j + 1), f(i, j));
            }
            // i - 1, j
            // i + 1, j
            // i, j + 1
        }
        if (j < w){
            for (int i = 1; i <= h; i++){
                if (x[i][j] == x[i][j + 1]){
                    R.unite(f(i, j), f(i, j + 1));
                }
            }
        }
        R.cnt += h;
        out[j - 1] += R.cnt;
    }
    int mini = k;
    for (int i = 1; i < w; i++){
        mini = min(mini, out[i]);
    }
    cout<<mini;
}