#include <bits/stdc++.h>
using namespace std;

const int n_max = 500005;
// const int n_max = 10;

struct Seg {
    int rank;
    int ind;
    int par;
    
    Seg()
    {
        par = -1;
        rank = 1;
    }
};

int find_seg(vector<Seg> &s, int ind)
{
    while (s[ind].par != -1) ind = s[ind].par;
    return ind;
}

void merge(vector<Seg> &s, int ind1, int ind2)
{
    if (ind1 == ind2) return;
    if (s[ind1].rank > s[ind2].rank) {
        s[ind2].par = ind1;
        return;
    }
    if (s[ind1].rank < s[ind2].rank) {
        s[ind1].par = ind2;
        return;
    }
    s[ind2].par = ind1;
    ++s[ind1].rank;
}

int l[n_max] = {0};
int r[n_max] = {0};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int h, w;
    cin>>h>>w;
    vector<vector<int>> a(h, vector<int>(w));
    for (int i=0;i<h;++i) {
        for (int j=0;j<w;++j) cin>>a[i][j];
    }
    vector<Seg> s(h*w);
    int cnt = 1;
    s[0].ind = 0;
    for (int i=1;i<h;++i) {
        s[i].ind = i;
        if (a[i][0] != a[i-1][0]) ++cnt;
        else merge(s, i, find_seg(s, i-1));
    }
    l[0] = cnt;
    for (int j=1;j<w-1;++j) {
        s[j*h].ind = j*h;
        if (a[0][j] == a[0][j-1]) merge(s, j*h, find_seg(s, (j-1)*h));
        else ++cnt;
        for (int i=1;i<h;++i) {
            if (a[i][j] == a[i][j-1] && a[i][j] == a[i-1][j]) {
                int seg1 = find_seg(s, j*h+i-1), seg2 = find_seg(s, (j-1)*h+i);
                if (seg1 != seg2) {
                    merge(s, seg1, seg2);
                    --cnt;
                }
                merge(s, seg1, j*h+i);
            } else if (a[i][j] == a[i][j-1]) {
                merge(s, find_seg(s, (j-1)*h+i), j*h+i);
            } else if (a[i][j] == a[i-1][j]) {
                merge(s, find_seg(s, j*h+i-1), j*h+i);
            } else ++cnt;
        }
        l[j] = cnt;
    }
    cnt = 1;
    s[h*(w-1)].ind = 0;
    s[h*(w-1)].rank = 1;
    s[h*(w-1)].par = -1;
    for (int i=1;i<h;++i) {
        s[h*(w-1)+i].ind = i;
        s[h*(w-1)+i].rank = 1;
        s[h*(w-1)+i].par = -1;
        if (a[i][w-1] != a[i-1][w-1]) ++cnt;
        else merge(s, h*(w-1)+i, find_seg(s, h*(w-1)+i-1));
    }
    r[w-1] = cnt;
    for (int j=w-2;j>0;--j) {
        s[j*h].rank = 1;
        s[j*h].par = -1;
        if (a[0][j] == a[0][j+1]) merge(s, j*h, find_seg(s, (j+1)*h));
        else ++cnt;
        for (int i=1;i<h;++i) {
            s[j*h+i].rank = 1;
            s[j*h+i].par = -1;
            if (a[i][j] == a[i][j+1] && a[i][j] == a[i-1][j]) {
                int seg1 = find_seg(s, j*h+i-1), seg2 = find_seg(s, (j+1)*h+i);
                if (seg1 != seg2) {
                    merge(s, seg1, seg2);
                    --cnt;
                }
                merge(s, seg1, j*h+i);
            } else if (a[i][j] == a[i][j+1]) {
                merge(s, find_seg(s, (j+1)*h+i), j*h+i);
            } else if (a[i][j] == a[i-1][j]) {
                merge(s, find_seg(s, j*h+i-1), j*h+i);
            } else ++cnt;
        }
        r[j] = cnt;
    }
    
//    for (int i=0;i<h;++i) {
//        for (int j=0;j<w;++j) cout<<find_seg(s, h*j+i)<<"  ";
//        cout<<'\n';
//    }
    
    int res = 1e9;
    for (int i=0;i<w-1;++i) res = min(res, l[i]+r[i+1]);
    cout<<res<<'\n';
}

